//
//  UIResponder+Helper.m
//  NNCategory
//
//  Created by BIN on 2018/11/22.
//

#import "UIResponder+Helper.h"

@implementation UIResponder (Helper)

-(UIResponder *_Nullable)nextResponder:(NSString *)responderName{
    UIResponder *next = self.nextResponder;
    while (next){
        if ([next isKindOfClass:[NSClassFromString(responderName) class]]){
            return next;
        }
        next = [next nextResponder];
    }
    return nil;
}

/**
 *  @brief  响应者链
 *  @return  响应者链
 */
- (NSString *)responderChainDescription{
    NSMutableArray *responderChainStrings = [NSMutableArray array];
    [responderChainStrings addObject:[self class]];
    UIResponder *nextResponder = self;
    while ((nextResponder = [nextResponder nextResponder])) {
        [responderChainStrings addObject:[nextResponder class]];
    }
    __block NSString *returnString = @"Responder Chain:\n";
    __block int tabCount = 0;
    [responderChainStrings enumerateObjectsWithOptions:NSEnumerationReverse
                                            usingBlock:^(id obj, NSUInteger idx, BOOL *stop) {
                                                if (tabCount) {
                                                    returnString = [returnString stringByAppendingString:@"|"];
                                                    for (int i = 0; i < tabCount; i++) {
                                                        returnString = [returnString stringByAppendingString:@"----"];
                                                    }
                                                    returnString = [returnString stringByAppendingString:@" "];
                                                }
                                                else {
                                                    returnString = [returnString stringByAppendingString:@"| "];
                                                }
                                                returnString = [returnString stringByAppendingFormat:@"%@ (%@)\n", obj, @(idx)];
                                                tabCount++;
                                            }];
    return returnString;
}

@end
